#pragma once
#include "object.h"
#include <iostream>
class Animal :
	public Object
{
public:
	Animal(void);
	~Animal(void);
	friend std::istream& operator>>(std::istream& in, Animal& animal);
	int getSafetyLimit()const
	{
		return safetyLimit;
	}
	int getActionIndex()const
	{
		return actionIndex;
	}
	int getAffectedFields()const
	{
		return fieldsAffected;
	}
	int getEffectOnField()const
	{
		return actionIndex * fieldsAffected;
	}
	int getId()const
	{
		return id;
	}
protected:
	virtual void readMatrix(std::istream& in);
private:
	int actionIndex;
	int safetyLimit;
	int id;
	static int lastId;
	int fieldsAffected;
};

