#pragma once
#include "Animal.h"
#include <vector>
#include <iostream>
#include <functional>
#include "Object.h"
#include "Result.h"
class Field : public Object
{
public:
	Field(Result& result);
	virtual ~Field(void);
	friend std::istream& operator>>(std::istream& in, Field& field);
	void startJumps();
	int getAnimalCount()const
	{
		return animalCount;	
	}
	int getMaxSafety()const
	{
		return maxSafety;
	}
	void sortByEffectOnField();
private:
	int maxSafety;
	int makeTheSafestJump(const Animal* animal);
	void createWorkMatrix();
	void destroyWorkMatrix();
	int calcSafetyIndex(const Animal& animal, int x, int y)const;
	void makeJump(const Animal& animal, int x, int y);
	std::vector<Animal> animals;
	std::vector<Animal*> sortedAnimals;
	int animalCount;
	int** workMatrix;
	Result& result;
};

